<template>
  <div>
    <a-row class="style--button">
      <a-col :span="8">
        <slot name="btn-search"></slot>
      </a-col>
      <a-col :span="6">
        <slot name="btn-add"></slot>
      </a-col>
    </a-row>
    <a-table bordered :size="size" :data-source="data.dataSource" :columns="columns" :loading="props.onLoadingTable"
      :pagination="false">
      <template #headerCell="{ column }">
        <template v-if="column.key === 'action'">
          <span>Thao tác</span>
        </template>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'status'">
          <span>
            <a-tag :color="record.isActive ? 'green' : 'gray'">
              {{ record.isActive ? "Hoạt động" : "Không hoạt động" }}
            </a-tag>
          </span>
        </template>
        <template v-if="column.key === 'operation'">
          <a-button @click="handleEditData(record)" type="link" size="large">
            <edit-outlined :style="color = 'blue'" />
          </a-button>
          <a-button @click="handleUpdateActive(record)" type="link" size="large">
            <unlock-outlined v-if="record.isActive" />
            <lock-outlined v-else />
          </a-button>
          <a-button @click="handleDeleteAccount(record)" type="text" danger size="large">
            <delete-outlined />
          </a-button>
          <slot name="btn-see" :propName="record"></slot>
        </template>
      </template>
    </a-table>
    <a-pagination class="pagination" v-model:current="data.currentPage" :total="data.totalElement" show-size-changer
      @change="handleGetAccount" />
  </div>
</template>

<script setup>
import { Modal } from 'ant-design-vue';
import { ref, createVNode } from "vue";
import { array, shape, number, func, oneOf, bool } from "vue-types";
import { LockOutlined, UnlockOutlined, EditOutlined, DeleteOutlined, PlusOutlined } from '@ant-design/icons-vue';

import { useLoading } from "@/utils/hooks";
import { TABLE_SIZE } from "@/utils/constants";

import '../styles/DataTable.css'
import DataModal from "../views/view-b/child-content/DataModal.vue";

const props = defineProps({
  data: shape({
    totalElement: number().isRequired,
    dataSource: array().isRequired,
    currentPage: number().isRequired,
  }),
  columns: array().def([]),
  size: oneOf([TABLE_SIZE.small, TABLE_SIZE.medium, TABLE_SIZE.large]),
  onGetData: func(),
  onAddData: func(),
  onDeleteData: func(),
  onUpdateActive: func(),
  onLoadingTable: bool()
});

const emit = defineEmits(['editData'])
const tableLoading = useLoading();

const currentPage = ref(1);

const handleEditData = async (data) => {
  emit('editData', data)
}

const handleGetAccount = async (params) => {
  try {
    await props.onGetData(params);
  } catch (e) {
    alert(e)
  }
};

const handleDeleteAccount = async (params) => {
  try {
    props.onDeleteData(params);
  } catch (e) {
    alert(e)
  }
}

const handleUpdateActive = async (params) => {
  try {
    props.onUpdateActive(params);
  } catch (e) {
    alert(e)
  }
}
</script>